unit HintWnd;
{The unit creates popup window, like Hint. Main difference from Hint -
 the window is filled with externat routine, which has type of
  TGraphicDrawNotify = procedure(Sender:TObject; Canvas:TCanvas) of object;
The routine may paint ant windows, as it want.
  Another property - Color - background color of this window (default -Yellow).

FreeWare. No warranty.

Author: Sergei Trepalin
E-mail: trep@trep.home.chg.ru}

interface
uses
  Controls, Messages, Windows, Classes, Graphics, Forms;

type
  TGraphicDrawNotify = procedure(Sender:TObject; Canvas:TCanvas) of object;

  TGraphHintWindow=class(TCustomControl)
  private
    FOnPaint:TGraphicDrawNotify;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure ActivateHint(Rect:TRect); virtual;
    procedure ReleaseHandle;
    property Color;
    property OnPaint:TGraphicDrawNotify read FOnPaint write FOnPaint;
  published
  end;

implementation
{------------------------------------------------------------------}
constructor TGraphHintWindow.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Color := $00FFFF;
  FOnPaint:=nil;
end;

procedure TGraphHintWindow.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do  begin
    Style:=WS_POPUP or WS_BORDER or WS_DISABLED;
    WindowClass.Style := WindowClass.Style or CS_SAVEBITS;
    if NewStyleControls then ExStyle := WS_EX_TOOLWINDOW;
  end;
end;

procedure TGraphHintWindow.Paint;
begin
  Canvas.Brush.Color:=Color;
  if Assigned(FOnPaint) then FOnPaint(Self,Canvas);
end;

procedure TGraphHintWindow.ReleaseHandle;
begin
  DestroyHandle;
end;

procedure TGraphHintWindow.ActivateHint(Rect:TRect);
begin
  BoundsRect:=Rect;
  if Rect.Top+Height>Screen.Height then Rect.Top:=Screen.Height-Height;
  if Rect.Left+Width>Screen.Width then Rect.Left:=Screen.Width-Width;
  if Rect.Left<0 then Rect.Left:=0;
  if Rect.Bottom<0 then Rect.Bottom:=0;
  SetWindowPos(Handle,HWND_TOPMOST,Rect.Left,Rect.Top,0,
    0,SWP_SHOWWINDOW or SWP_NOACTIVATE or SWP_NOSIZE);
end;
{----------------------------------------------------------------}

end.
